/******************************************************************************
 * JBoss, a division of Red Hat                                               *
 * Copyright 2006, Red Hat Middleware, LLC, and individual                    *
 * contributors as indicated by the @authors tag. See the                     *
 * copyright.txt in the distribution for a full listing of                    *
 * individual contributors.                                                   *
 *                                                                            *
 * This is free software; you can redistribute it and/or modify it            *
 * under the terms of the GNU Lesser General Public License as                *
 * published by the Free Software Foundation; either version 2.1 of           *
 * the License, or (at your option) any later version.                        *
 *                                                                            *
 * This software is distributed in the hope that it will be useful,           *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU           *
 * Lesser General Public License for more details.                            *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public           *
 * License along with this software; if not, write to the Free                *
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA         *
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.                   *
 ******************************************************************************/
package org.jboss.portletbridge.component;

import org.ajax4jsf.component.AjaxViewRoot;

import javax.faces.component.NamingContainer;
import javax.faces.context.FacesContext;
import javax.faces.context.ExternalContext;
import javax.faces.event.PhaseId;
import javax.faces.render.Renderer;
import javax.faces.component.UIViewRoot;
import java.io.IOException;
import javax.portlet.faces.annotation.PortletNamingContainer;

/**
 * @author <a href="mailto:whales@redhat.com">Wesley Hales</a>
 * @version $Revision: 630 $
 */
@PortletNamingContainer
public class UIPortletAjaxViewRoot extends AjaxViewRoot implements
        NamingContainer {

	public static final String PORTLET_VIEW_ROOT_RENDERER = "org.jboss.portletbridge.ViewRoot";
   private String clientId;

	public UIPortletAjaxViewRoot() {
		super();
	}

   @Override
   public String getClientId(FacesContext context) {
      // TODO - cache clientId.
//		if (null == this.clientId) {
         this.clientId = UIPortletViewRoot.convertClientId(context, this,
               super.getId());
         // allow the renderer to convert the clientId
         Renderer renderer = this.getRenderer(context);
         if (renderer != null) {
            this.clientId = renderer
                  .convertClientId(context, this.clientId);
         }

//		}
      return this.clientId;
   }
}
